/*------------------------------------------------------------------------------*
 * Architecture & Implementation of DBMS                                        *
 *------------------------------------------------------------------------------*
 * Copyright 2020 Databases and Information Systems Group TU Dortmund           *
 * Visit us at                                                                  *
 *             http://dbis.cs.tu-dortmund.de/cms/en/home/                       *
 *                                                                              *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL      *
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR         *
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,        *
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR        *
 * OTHER DEALINGS IN THE SOFTWARE.                                              *
 *                                                                              *
 * Authors (alphabetical list):                                                 *
 *          Maximilian Berens   <maximilian.berens@tu-dortmund.de>              *
 *          Roland Kühn         <roland.kuehn@cs.tu-dortmund.de>                *
 *          Jan Mühlig          <jan.muehlig@tu-dortmund.de>                    *
 *------------------------------------------------------------------------------*
 */

//#include <execution/aggregate_operator.h>
//#include <exception/column_not_grouped_exception.h>
//#include <expression/attribute.h>
//
// using namespace beedb::execution;
//
// AggregateOperator::AggregateOperator(const table::Schema& schema,
//                                     const std::vector<expression::Attribute> &groups,
//                                     const std::vector<expression::Attribute> &columns)
//    : AbstractOperator(schema),_groups(groups), _columns(columns)
//{
//}
//
// void AggregateOperator::initialize()
//{
//
//    /// TODO: Output schema is going to be generated outside of operators!
//
////    const auto& child_schema = this->child<AbstractOperator>(0)->schema();
//
////    for(auto i = 0u; i < child_schema.size(); i++) {
////        const auto& child_column = child_schema[i];
////        const auto& child_name = child_column.name();
////        const auto& child_table_name = child<AbstractOperator>(0)->table_name();
////        for(const auto &column : this->_columns) {
////            if(child_table_name == column.table_alias() && child_name == column.column_name()) {
////                if(column.is_aggregation()) {
////                    this->_schema.add({this->aggregation_column_type(column.aggregation_type(),
/// child_column.type()), child_name}, child_table_name); /                    const auto index = this->_schema.size() -
/// 1; /                    this->_schema_index_aggregation_map[index] = column.aggregation_type(); /
/// this->_schema_index_map[index] = i; /                    this->_aggregation_indices.push_back(index); / break; / } /
///} /        }
//
////        for(const auto &column : this->_groups) {
////            if(child_table_name == column.table_alias() && child_name == column.column_name()) {
////                this->_schema.add(child_column, child_table_name);
////                break;
////            }
////        }
////    }
//}
//
// beedb::table::Type AggregateOperator::aggregation_column_type(const beedb::expression::AttributeOrigin aggregation,
//                                                       const beedb::table::Type &column_type)
//{
//    if(aggregation == beedb::expression::AttributeOrigin::AGG_COUNT) {
//        return table::Type::LONG;
//    } else if(aggregation == beedb::expression::AttributeOrigin::AGG_AVG) {
//        return table::Type::FLOAT;
//    } else {
//        return column_type;
//    }
//}
//
// std::vector<beedb::table::Tuple> AggregateOperator::execute()
//{
//    std::vector<table::Tuple> input_tuples = this->child<OperatorAtATimeInterface>(0)->execute();
//    if(input_tuples.empty() && this->_aggregated) {
//        return {};
//    }
//    this->_aggregated = true;
//
//    Aggregator aggregator;
//    std::vector<table::Tuple> output_tuples;
//
//    if(this->_groups.empty()) {
//        table::Tuple tuple(this->_schema, this->_schema.row_size());
//        for(const auto index : this->_aggregation_indices) {
//            const auto aggregate_function = this->_schema_index_aggregation_map[index];
//            const auto source_index = this->_schema_index_map[index];
//            if(aggregate_function == beedb::expression::AttributeOrigin::AGG_AVG) {
//                aggregator.avg(input_tuples, source_index, tuple, index);
//            } else if(aggregate_function == beedb::expression::AttributeOrigin::AGG_MIN) {
//                aggregator.min(input_tuples, source_index, tuple, index);
//            } else if(aggregate_function == beedb::expression::AttributeOrigin::AGG_MAX) {
//                aggregator.max(input_tuples, source_index, tuple, index);
//            } else if(aggregate_function == beedb::expression::AttributeOrigin::AGG_SUM) {
//                aggregator.sum(input_tuples, source_index, tuple, index);
//            } else if(aggregate_function == beedb::expression::AttributeOrigin::AGG_COUNT) {
//                aggregator.count(input_tuples, tuple, index);
//            }
//        }
//        output_tuples.push_back(std::move(tuple));
//    } else {
//        std::vector<std::uint32_t> indices;
//        std::unordered_map<std::size_t, std::vector<table::Tuple>> hash_aggregation;
//        for(auto& tuple : input_tuples) {
//            const auto hash = this->hash(indices, tuple);
//            hash_aggregation[hash].push_back(table::Tuple(tuple.schema(), std::move(tuple)));
//        }
//
//        output_tuples.reserve(hash_aggregation.size());
//        const auto row_size = this->_schema.row_size();
//        for(auto& [_, input_tuples] : hash_aggregation) {
//            table::Tuple out_tuple(this->_schema, row_size);
//            for(const auto index : this->_aggregation_indices) {
//                const auto aggregate_function = this->_schema_index_aggregation_map[index];
//                const auto source_index = this->_schema_index_map[index];
//                if(aggregate_function == expression::AttributeOrigin::AGG_AVG) {
//                    aggregator.avg(input_tuples, source_index, out_tuple, index);
//                } else if(aggregate_function == expression::AttributeOrigin::AGG_MIN) {
//                    aggregator.min(input_tuples, source_index, out_tuple, index);
//                } else if(aggregate_function == expression::AttributeOrigin::AGG_MAX) {
//                    aggregator.max(input_tuples, source_index, out_tuple, index);
//                } else if(aggregate_function == expression::AttributeOrigin::AGG_SUM) {
//                    aggregator.sum(input_tuples, source_index, out_tuple, index);
//                } else if(aggregate_function == expression::AttributeOrigin::AGG_COUNT) {
//                    aggregator.count(input_tuples, out_tuple, index);
//                }
//            }
//            output_tuples.push_back(std::move(out_tuple));
//        }
//    }
//
//    return output_tuples;
//}
//
// void Aggregator::avg(const std::vector<table::Tuple> &source_tuples, const std::size_t source_index, table::Tuple
// &target_tuple, const std::size_t target_index)
//{
//    if(source_tuples.empty()) {
//        return;
//    }
//
//    auto source_type = source_tuples[0].schema()[source_index].type();
//    table::Value sum { source_type, 0 };
//    for(const auto& tuple : source_tuples) {
//        sum += tuple.get(source_index);
//    }
//
//    float avg;
//    if(sum == table::Type::LONG) {
//        avg = sum.get<std::int64_t>() / float(source_tuples.size());
//    } else if(sum == table::Type::INT) {
//        avg = sum.get<std::int32_t>() / float(source_tuples.size());
//    } else if(sum == table::Type::FLOAT) {
//        avg = sum.get<float>() / float(source_tuples.size());
//    } else if(sum == table::Type::DOUBLE) {
//        avg = sum.get<double>() / float(source_tuples.size());
//    }
//
//    target_tuple.set(target_index, avg);
//}
//
// void Aggregator::min(const std::vector<table::Tuple> &source_tuples, const std::size_t source_index, table::Tuple
// &target_tuple, const std::size_t target_index)
//{
//    auto max_value = target_tuple.get(target_index).max();
//    target_tuple.set(target_index, max_value);
//
//    for(const auto& tuple : source_tuples) {
//        auto v = tuple.get(source_index);
//        if(v < target_tuple.get(target_index)) {
//            target_tuple.set(target_index, v);
//        }
//    }
//}
//
// void Aggregator::max(const std::vector<table::Tuple> &source_tuples, const std::size_t source_index, table::Tuple
// &target_tuple, const std::size_t target_index)
//{
//    auto min_value = target_tuple.get(target_index).min();
//    target_tuple.set(target_index, min_value);
//
//    for(const auto& tuple : source_tuples) {
//        auto v = tuple.get(source_index);
//        if(v > target_tuple.get(target_index)) {
//            target_tuple.set(target_index, v);
//        }
//    }
//}
//
// void Aggregator::sum(const std::vector<table::Tuple> &source_tuples, const std::size_t source_index, table::Tuple
// &target_tuple, const std::size_t target_index)
//{
//    auto sum = target_tuple.get(target_index);
//    for(const auto& tuple : source_tuples) {
//        sum += tuple.get(source_index);
//    }
//    target_tuple.set(target_index, sum);
//}
//
// void Aggregator::count(const std::vector<table::Tuple> &source_tuples, table::Tuple &target_tuple, const std::size_t
// target_index)
//{
//    auto result = target_tuple.get(target_index).get<std::int64_t>() + std::int64_t(source_tuples.size());
//    target_tuple.set(target_index, result);
//}
//
// std::size_t AggregateOperator::hash(const std::vector<std::uint32_t> &group_indices,
//                                    const beedb::table::Tuple &tuple)
//{
//    std::size_t h = 0u;
//    for(const auto index : group_indices) {
//        h += std::hash<table::Value>()(tuple.get(index));
//    }
//    return std::hash<std::size_t>()(h);
//}