/*------------------------------------------------------------------------------*
 * Architecture & Implementation of DBMS                                        *
 *------------------------------------------------------------------------------*
 * Copyright 2020 Databases and Information Systems Group TU Dortmund           *
 * Visit us at                                                                  *
 *             http://dbis.cs.tu-dortmund.de/cms/en/home/                       *
 *                                                                              *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL      *
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR         *
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,        *
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR        *
 * OTHER DEALINGS IN THE SOFTWARE.                                              *
 *                                                                              *
 * Authors (alphabetical list):                                                 *
 *          Maximilian Berens   <maximilian.berens@tu-dortmund.de>              *
 *          Roland Kühn         <roland.kuehn@cs.tu-dortmund.de>                *
 *          Jan Mühlig          <jan.muehlig@tu-dortmund.de>                    *
 *------------------------------------------------------------------------------*
 */

//#pragma once
//
//#include "abstract_operator.h"
//#include "operator_at_a_time_interface.h"
//#include <unordered_map>
//#include <vector>
//
//#include "expression/attribute.h"
//
// namespace beedb::execution {
//    class Aggregator
//    {
//    public:
//        void sum(const std::vector<table::Tuple>& source_tuples, const std::size_t source_index, table::Tuple&
//        target_tuple, const std::size_t target_index); void avg(const std::vector<table::Tuple>& source_tuples, const
//        std::size_t source_index, table::Tuple& target_tuple, const std::size_t target_index); void min(const
//        std::vector<table::Tuple>& source_tuples, const std::size_t source_index, table::Tuple& target_tuple, const
//        std::size_t target_index); void max(const std::vector<table::Tuple>& source_tuples, const std::size_t
//        source_index, table::Tuple& target_tuple, const std::size_t target_index); void count(const
//        std::vector<table::Tuple>& source_tuples, table::Tuple& target_tuple, const std::size_t target_index);
//    };
//
//    class AggregateOperator : public AbstractOperator, public OperatorAtATimeInterface
//    {
//    public:
//        AggregateOperator(const table::Schema& schema,
//                          const std::vector<expression::Attribute>& groups,
//                          const std::vector<expression::Attribute>& columns);
//        virtual ~AggregateOperator() = default;
//
//        virtual void initialize();
//        virtual std::vector<table::Tuple> execute();
//    private:
//        bool _aggregated = false;
//        const std::vector<expression::Attribute>& _groups;
//        const std::vector<expression::Attribute>& _columns;
//        std::unordered_map<std::uint32_t, const expression::AttributeOrigin> _schema_index_aggregation_map;
//        std::unordered_map<std::uint32_t ,std::uint32_t> _schema_index_map;
//        std::vector<std::uint32_t> _aggregation_indices;
//        std::vector<std::uint32_t> _group_indices;
//
//        table::Type aggregation_column_type(const expression::AttributeOrigin aggregation, const table::Type&
//        column_type); std::size_t hash(const std::vector<std::uint32_t>& group_indices, const table::Tuple& tuple);
//    };
//}